const { char_dict, full_dict } = require('./dist.json')

module.exports = class Ch2py {
    constructor(hump = true) {
        this.hump = hump
    }
    getFullChars(str) {
        if (typeof str !== 'string') throw new Error('请传入一个字符串')
        return str.split('').map(ch => {
            const unicode = ch.charCodeAt(0)
            if (unicode < 19968 || unicode > 40869) return ch
            for (let key in full_dict) {
                if (full_dict[key].includes(ch)) {
                    if (!this.hump) return key
                    return key.substr(0, 1).toUpperCase() + key.substr(1);
                }
            }
            throw new Error(`“${ch}”尚未被收录，可自行添加，欢迎提issue`)
        }).join('')
    }
    getCamelChars(str) {
        if (typeof str !== 'string') throw new Error('请传入一个字符串')
        return str.split('').map(ch => {
            const unicode = ch.charCodeAt(0)
            if (unicode < 19968 || unicode > 40869) return ch
            return this.hump ? char_dict.charAt(unicode - 19968) : char_dict.charAt(unicode - 19968).toLowerCase();
        }).join('')
    }
    static test(arrOrStr, val) {
        if (typeof val !== 'string') throw new Error('第二个参数应该传入一个字符串')
        const arr = Array.isArray(arrOrStr) ? arrOrStr : [arrOrStr]
        if (!arr.every(item => typeof item === 'string')) throw new Error('第一个参数应该传入一个字符串或只包含字符串的数组')
        return arr.some(item => item.toLowerCase().includes(val.toLowerCase()))
    }
    static sortby(a, b) {
        for (let i = 0; i < a.length; i++) {
            const aiCode = a[i].toLowerCase().charCodeAt()
            if (aiCode < 97 || aiCode > 122) return 1
            const bi = b[i]
            if (!bi) return 1
            const biCode = bi.toLowerCase().charCodeAt()
            if (biCode < 97 || biCode > 122) return -1
            if (aiCode === biCode) continue
            return aiCode - biCode
        }
        return a.length - b.length
    }
}